#include "mint.h"

/* time that bus is busy until */
static mint_time_t Bus_busy_until;

/* duration of a bus request (in processor cycles, not bus cycles) */
#define BUS_BUSY 50

void
issue_bus_request(task_ptr ptask, PFTASK func_retry, PFTASK func_done,
                  void *uptr)
{
    task_ptr newtask;

    /* If the current time is past the time the bus is busy until,
     * then the bus is free.
     */
    if (ptask->time >= Bus_busy_until) {
        /* bus is free, make it busy for BUS_BUSY cycles */
        Bus_busy_until = ptask->time + BUS_BUSY;

        /* schedule the done function BUS_BUSY cycles from now */
        newtask = pri_sched_task(ptask, func_done, Bus_busy_until, 10);
        newtask->uptr = uptr;	/* save the user-defined pointer */
    } else {
        /* bus is busy, schedule the retry function at Bus_busy_until */
        newtask = sched_task(ptask, func_retry, Bus_busy_until);
        newtask->uptr = uptr;	/* save the user-defined pointer */
    }
}
