/* 
 * Please read the COPYRIGHT notice included at the top level
 */

#ifndef	_REGISTERS_H
#define	_REGISTERS_H

/*
 * registers.h,v 1.1.1.1 1996/07/18 22:39:59 arsharma Exp
 * Purpose : To define the register masks to perform the register
 * usage analyisis
 */

#define	EAX_MASK 0x00000001
#define	EBX_MASK 0x00000002
#define	ECX_MASK 0x00000004
#define	EDX_MASK 0x00000008
#define	EBP_MASK 0x00000010
#define	ESI_MASK 0x00000020
#define	EDI_MASK 0x00000040
#define	ESP_MASK 0x00000080

#define	CS_MASK	0x00000100
#define	SS_MASK	0x00000200
#define	DS_MASK	0x00000400
#define	ES_MASK	0x00000800
#define	FS_MASK	0x00001000
#define	GS_MASK	0x00002000

/*
 * A macro for checking       if instr uses the registers specified in the
 * mask
 */
#define	CHECK_USAGE(instr,mask)	 (((instr)->reg_mask) &	(mask))

/* prototypes */
char *get_unused_register (instr_t *instr, int size);

/*
 * A macro for finding the word       register corresponding to a byte
 * register, assuming that both are pointers to the register table
 */
#define	WORD_REG(byte_register)	\
		 ((byte_reg_table - byte_register) + word_register_table)

extern char *register_table[];
extern char *word_register_table[];
extern char *byte_register_table[];

#endif /* _REGISTERS_H */
